// simulationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "simulation.h"
#include "simulationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CsimulationDlg dialog




CsimulationDlg::CsimulationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CsimulationDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	height=700;
	width=505;
	
	Brush =new CBrush(RGB(255,255,255));
	Brush2 =new CBrush(RGB(0,0,0));
	
	leftMargin=50;
	upMargin=50;
}

void CsimulationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CsimulationDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CsimulationDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CsimulationDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CsimulationDlg message handlers

BOOL CsimulationDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	SetDlgItemTextA(IDC_PolyTime,"7");
	SetDlgItemTextA(IDC_BindingDelay,"5");
	SetDlgItemTextA(IDC_PromoterBias,"0.5");
	SetDlgItemTextA(IDC_RepressL,"0.5");
	SetDlgItemTextA(IDC_RepressR,"0.5");
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CsimulationDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.


void CsimulationDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CsimulationDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CsimulationDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here

	srand((int)time(0));

	double m_time=0;	//current time
//	char str[100];
	int i=0,j=0,k=0;	//temporary variables
	int index=0;
	double t1=0,t2=0,t3=0;
	double interval=0;
	double successRate=0;
	double bias=0;
	const int polypertest=100;	//number of polymerase in each cell
	const int TestNum=200;	//number of cells
	double polytime=0;	//a1
	double bindingdelay=0;	//a2
	double promoterBias=0;	//a3
	double bindingtime=1;	//binding delay
	int k_represseff[2];
	double represseff[2];
	double repressRate[2];
	const double represseffList[2][5]={{0.3,0.5,0.7,0.9,0.99},{0.3,0.5,0.7,0.9,0.99}};	//a4, a5

	
	//parameter initialization
	int x1=0,y1=0,x2=0,y2=0;

	CDC* pDC=GetDC();


	fstream fout;
	fout.open("output.txt",fstream::out);	
	fout<<"a1\t"
		<<"a2\t"
		<<"a3\t"
		<<"a4\t"
		<<"a5\t"
		<<"success rate\t"
		<<"bias\n";

	//initialization for each set of parameters
	for (polytime=1;polytime<=10;polytime++)
	{
		for (bindingdelay=5;bindingdelay<=9;bindingdelay++)
		{
			for (promoterBias=0.3;promoterBias<=0.7;promoterBias+=0.1)
			{
				for (k_represseff[0]=0;k_represseff[0]<5;k_represseff[0]++)
				{
					represseff[0]=represseffList[0][k_represseff[0]];//1-pow(0.5,k_represseff[0]/2);
					for (k_represseff[1]=0;k_represseff[1]<5;k_represseff[1]++)
{
//	k_represseff[1]=k_represseff[0];
	represseff[1]=represseffList[1][k_represseff[1]];
//	represseff[1]=1-pow(2,0-k_represseff[1]/2);
	if((represseff[0]/represseff[1]>2)||(represseff[1]/represseff[0]>2)) continue;

	for (i=0;i<TestNum;i++)
	{
		nProtein[i][0]=0;
		nProtein[i][1]=0;
		ratio[i]=0;
	}
	
	//from 0% to 100%
	for (i=0;i<101;i++)
		distribution[i]=0;

/*	
	CRect ViewClip(leftMargin,upMargin,width+leftMargin,height+upMargin);
	pDC->FillRect(ViewClip,Brush);
	pDC->Rectangle(leftMargin,upMargin,leftMargin+width,upMargin+height);	
*/

	//repeat 'TestNum' Tests
	nTest=0;
	while(nTest<TestNum)
	{
		//initialization for each test
		m_RNA.clear();
		repressRate[0]=0;
		repressRate[1]=0;
		m_time=0;

		
		for (i=0;i<polypertest;i++)
		{
			t1=polytime+polytime*generateRand();
			m_time+=t1;
			
			if (generateRand()<promoterBias)
				direction=0;
			else 
				direction=1;

			//update protain number based on RNA number
			for (j=0;j<int(m_RNA.size());j++)
			{
				while (m_RNA[j].TransNum<m_RNA[j].MaxProtein)
				{
					interval=m_time-bindingtime-m_RNA[j].lastTransTime;
					if (m_RNA[j].TransNum==0)
					{
						t2=bindingdelay+bindingdelay*generateRand();
						if (interval>=t2)
						{
							m_RNA[j].TransNum++;
							nProtein[nTest][m_RNA[j].direction]++;
							m_RNA[j].lastTransTime+=t2;
						}
						else
							break;
					}
					else if (interval>=2)
					{
						m_RNA[j].TransNum++;
						nProtein[nTest][m_RNA[j].direction]++;
						m_RNA[j].lastTransTime+=2;
					}
					else
						break;
				}
				if (m_RNA[j].TransNum==m_RNA[j].MaxProtein) 
				{
					m_RNA.erase(m_RNA.begin()+j);
					j--;
				}
			}
			
			//update repressRate based on protein number
			for (k=0;k<2;k++)
			{
				repressRate[k]=1-pow((1-represseff[k]),nProtein[nTest][k]);
			/*	if (nProtein[nTest][direction]>nProtein[nTest][1-direction])
				{
					repressRate[direction]=1-pow((1-represseff[direction]),nProtein[nTest][direction]-nProtein[nTest][1-direction]);
					repressRate[1-direction]=0;
				}
				else
				{
					repressRate[1-direction]=1-pow((1-represseff[1-direction]),-nProtein[nTest][direction]+nProtein[nTest][1-direction]);
					repressRate[direction]=0;
				}*/
			
			}

			if (generateRand()>repressRate[1-direction])
			{
				t3=0.225+0.02*generateRand();
				RNA t_RNA;
				t_RNA.birthtime=m_time+t3;
				t_RNA.direction=direction;
				t_RNA.lastTransTime=m_time+t3;
				t_RNA.TransNum=0;
				t_RNA.MaxProtein=int(10+11*generateRand());
				m_RNA.push_back(t_RNA);
			}

		}
		if ((nProtein[nTest][0]+nProtein[nTest][1])!=0)
		{	
			ratio[nTest]=(double)nProtein[nTest][1]/(double)(nProtein[nTest][0]+nProtein[nTest][1]);

		}
		//one test ends
		nTest++;
	}
	//200 tests end i.e. one parameter set ends
	//output result to "output.txt"
	successRate=0;
	bias=0;
	for (i=0;i<TestNum;i++)
	{
		if (nProtein[i][0]+nProtein[i][1]>500)
		{
			if (ratio[i]<=0.05)
			{
				successRate+=1/(double)TestNum;
				bias+=1/(double)TestNum;
			}
			else if (ratio[i]>=0.95)
			{
				successRate+=1/(double)TestNum;
				bias-=1/(double)TestNum;
			}
		}
	
	}
	bias=bias/successRate;

	fout<<polytime<<"\t"
		<<bindingdelay<<"\t"
		<<promoterBias<<"\t"
		<<represseff[0]<<"\t"
		<<represseff[1]<<"\t"
		<<successRate<<"\t"
		<<bias<<"\n";

}}}}
}

	fout.close();
}

double CsimulationDlg::generateRand()
{
	return (double)(rand()%777)/777;
}


void CsimulationDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	srand((int)time(0));

	double m_time=0;	//current time
	char str[100];
	int i=0,j=0,k=0;	//temporary variables
	int index=0;
	double t1=0,t2=0,t3=0;
	double interval=0;
	double successRate=0;
	double bias=0;
	const int polypertest=1000;	//number of polymerase in each cell
	const int TestNum=1000;	//number of cells
	double polytime=0;	//a1
	double bindingdelay=0;	//a2
	double promoterBias=0;	//a3
	double represseff[2];	//a4 a5
	double bindingtime=1;	//binding delay
//	int k_represseff[2];
	double repressRate[2];
//	const double represseffList[2][5]={{0.3,0.5,0.7,0.9,0.99},{0.3,0.5,0.7,0.9,0.99}};	//a4, a5

	
	//parameter initialization
	int x1=0,y1=0,x2=0,y2=0;

	CDC* pDC=GetDC();


	GetDlgItemTextA(IDC_PolyTime,str,100);
	polytime=atof(str);	//set a1
	GetDlgItemTextA(IDC_BindingDelay,str,100);
	bindingdelay=atof(str);	//set a2
	GetDlgItemTextA(IDC_PromoterBias,str,100);
	promoterBias=atof(str);	//set a3
	GetDlgItemTextA(IDC_RepressL,str,100);
	represseff[0]=atof(str);	//set a4
	GetDlgItemTextA(IDC_RepressR,str,100);
	represseff[1]=atof(str);	//set a5

	//draw white background
	CRect ViewClip(leftMargin,upMargin,width+leftMargin,height+upMargin);
	pDC->FillRect(ViewClip,Brush);
	pDC->Rectangle(leftMargin,upMargin,leftMargin+width,upMargin+height);	


	for (i=0;i<TestNum;i++)
	{
		nProtein[i][0]=0;
		nProtein[i][1]=0;
		ratio[i]=0;
	}
	
	//from 0% to 100%
	for (i=0;i<101;i++)
		distribution[i]=0;

	//repeat 'TestNum' Tests
	nTest=0;
	while(nTest<TestNum)
	{
		//initialization for each test
		m_RNA.clear();
		repressRate[0]=0;
		repressRate[1]=0;
		m_time=0;

		
		for (i=0;i<polypertest;i++)
		{
			t1=polytime+polytime*generateRand();
			m_time+=t1;
			
			if (generateRand()<promoterBias)
				direction=0;
			else 
				direction=1;

			//update protain number based on RNA number
			for (j=0;j<int(m_RNA.size());j++)
			{
				while (m_RNA[j].TransNum<m_RNA[j].MaxProtein)
				{
					interval=m_time-bindingtime-m_RNA[j].lastTransTime;
					if (m_RNA[j].TransNum==0)
					{
						t2=bindingdelay+bindingdelay*generateRand();
						if (interval>=t2)
						{
							m_RNA[j].TransNum++;
							nProtein[nTest][m_RNA[j].direction]++;
							m_RNA[j].lastTransTime+=t2;
						}
						else
							break;
					}
					else if (interval>=2)
					{
						m_RNA[j].TransNum++;
						nProtein[nTest][m_RNA[j].direction]++;
						m_RNA[j].lastTransTime+=2;
					}
					else
						break;
				}
				if (m_RNA[j].TransNum==m_RNA[j].MaxProtein) 
				{	
					m_RNA.erase(m_RNA.begin()+j);
					j--;
				}
			}
			
			//update repressRate based on protein number
			for (k=0;k<2;k++)
			{
				repressRate[k]=1-pow((1-represseff[k]),nProtein[nTest][k]);
			/*	if (nProtein[nTest][direction]>nProtein[nTest][1-direction])
				{
					repressRate[direction]=1-pow((1-represseff[direction]),nProtein[nTest][direction]-nProtein[nTest][1-direction]);
					repressRate[1-direction]=0;
				}
				else
				{
					repressRate[1-direction]=1-pow((1-represseff[1-direction]),-nProtein[nTest][direction]+nProtein[nTest][1-direction]);
					repressRate[direction]=0;
				}*/
			
			}

			if (generateRand()>repressRate[1-direction])
			{
				t3=0.225+0.02*generateRand();
				RNA t_RNA;
				t_RNA.birthtime=m_time+t3;
				t_RNA.direction=direction;
				t_RNA.lastTransTime=m_time+t3;
				t_RNA.TransNum=0;
				t_RNA.MaxProtein=int(10+11*generateRand());
				m_RNA.push_back(t_RNA);
			}

		}
		if ((nProtein[nTest][0]+nProtein[nTest][1])!=0)
		{	
		ratio[nTest]=(double)nProtein[nTest][1]/(double)(nProtein[nTest][0]+nProtein[nTest][1]);

		sprintf_s(str,100,"left=%d, right=%d, ratio=%2.4f",nProtein[nTest][0],nProtein[nTest][1],ratio[nTest]);
		SetDlgItemTextA(IDC_RESULT,str);

		//draw

		index=(int)(ratio[nTest]*100);
		
		if ((ratio[nTest]*100-0.5)>=index)
			index++;

		distribution[index]++;

		x1=leftMargin+index*5;
		x2=leftMargin+index*5+5;
		y1=upMargin+height-distribution[index]*1;
		y2=upMargin+height;
		smallRect.SetRect(x1,y1,x2,y2);
		pDC->FillRect(smallRect,Brush2);
		}
		nTest++;
	}

}
